public class Polygon{
    Point[] vertices;
    
    // This constructor takes no input
    public Polygon(){
        vertices = null;
    }
    
    // This constructor will receives as input
    // an array of Point objects
    public Polygon( Point[] verts){
        this.vertices = verts;   
    }
    
    // This will print one vertex of the polygon per line
    public String toString(){
        // poly_str will contain the result of calling
        // toString for each vertex
        String poly_str = "";
        for(int i=0; i < this.vertices.length; i++){
            // this appends the new line character '\n'
            // to whatever the toString method of Point
            // returns
            poly_str += this.vertices[i].toString()+"\n";
        }
        
        // Finally return the string we have built
        return poly_str;
    }
    
    // this method will replace the this.vertices, with 
    // a new array that has Point p as the last element
    public void addVertex(Point p){
        // this is for the case when this.vertices == null
        int n = 0;
        // this is for when this.vertices has some elements
        if ( this.vertices != null){
            n = this.vertices.length;
        }
        // we declare a new vertices array of size n + 1
        Point[] new_verts = new Point[n+1];
        // Here we are copying the references contained in 
        // this.vertices to the new_verts array
        for (int i = 0; i < n; i++){
            new_verts[i] = vertices[i];
        }
        // here we assign a reference to p to the 
        // last position of the new_verts array
        new_verts[n] = p;
        
        // replace the old this.vertices array, with
        // the updated new_verts array
        this.vertices = new_verts;
    }
    
    // this method will check if our polygon is equilateral
    public boolean isEquilateral(){
        // we initialize distance to the distance of the 
        // first two vertices
        double distance = 
            this.vertices[0].distanceTo(this.vertices[1]);
        
        for ( int i=1; i< this.vertices.length - 1; i++){
            // if any subsequent distance is different
            // from the initial one, our polygon is not
            // equilateral
            if ( distance != 
                this.vertices[i].distanceTo(this.vertices[i+1])){
                return false;   
            }
        }
        // all the edges in the polygon
        /// passed the distance test
        return true;
    }
}